package base;

import java.sql.SQLException;
import java.util.Iterator;
import filter.Filter;
import filter.TokenContainer;

public class Main {


/**
 * @param args
 */
public static void main(String[] args) {
			
	try {
		
				
		//Create new Filter and hook it up to the DB
		String delimiter = "\\s+[.,;]*\\s*";
		Filter testFilter = new Filter("jdbc:mysql://localhost/test", "filter", "filter", delimiter);
		
		//Get a clean database
		testFilter.sanitizeDatabase();
		System.out.println("DATABASE has been sanitized");
								
		//TESTDATA --- REMOVE AFTER TESTING
		String s = new String("Das Team um den kostenlosen ISDN-, DSL- und Ethernet-Router fli4l hat die Version 3.0 des schlank gehaltenen Softwarerouters auf Basis von Linux freigegeben. Es lsst sich in der Grundausstattung auf einer Diskette installieren und arbeitet schon auf 486-Systemen mit 16 MByte Arbeitsspeicher. Fli4l lsst sich ber optionale Pakete aber auch stark erweitern, wobei es dann unter Umstnden einen schnelleren Rechner und Speichermedien mit mehr Platz erfordert; etwa Festplatten, Speicherkarten oder CDs.");
		String h = new String("Microsoft konkretisiert Schritt fr Schritt die Hardware-Voraussetzungen, die zur optimalen Nutzung aller Funktionen des im Herbst erwarteten Windows-XP-Nachfolger Vista ntig sein werden. Whrend das offizielle Vista-Logo-Programm (fr Hardware-Entwickler) zwar bereits mehrfach berarbeitet wurde, sich aber immer noch in einem Entwurfszustand (zurzeit 0.61) befindet, hat Microsoft den Windows-Experten Charlie Russel nun einen TechNet-Beitrag ber die Hardware-Anforderungen von Windows Vista schreiben lassen. Anzeige Russel geht auf die Kern-Komponenten Hauptprozessor, Grafikkarte, Hauptspeicher, Festplatte, optische Laufwerke und Netzwerkadapter ein. Er bezieht sich ausdrcklich auf Erfahrungen mit der Beta-1-Version von Vista und formuliert Hardware-Anforderungen, die die meisten heute verkauften Mittelklasse-PCs erfllen: Standard-Prozessor, 512 MByte Speicher, DirectX-9-Grafikkarte mit AGP- oder PCIe-Schnittstelle und 64 MByte lokalem Speicher, 7200-Touren-Festplatte, DVD-Brenner, 100-MBit-LAN-Chip und  vor allem bei Notebooks  802.11-kompatibler WLAN-Adapter. Auch neuere Chipstze mit eingebautem Grafikprozessor (GPU) sollen Vista-tauglich sein, wenn sie DirectX 9 untersttzen und mindestens 64 MByte vom Hauptspeicher belegen knnen, dann rt Russel aber zu einem Hauptspeicher von 1 GByte Kapazitt  das haben heute bereits Sonderangebote aus dem Lebensmittelmarkt. Es ist davon auszugehen, dass Windows Vista auch auf Rechnern mit weniger Speicher und schwcherer Grafikkarte funktioniert, mglicherweise sind dann aber Funktionen wie die neuartige Desktop-Darstellung Aero (Glass) nicht nutzbar; Aero setzt auf die Windows Presentation Foundation (vormals Avalon), die 3D-Funktionen des Grafikchips verwendet und den Desktop-Inhalt in Form von 3D-Texturen zur Grafikkarte schickt. Die aktuellen Vista-Logo-Richtlinien werden diesbezglich wesentlich konkreter als Russel: Um nicht nur ein Standard-Logo, sondern die Premium-Version auf die Grafikkarte beziehungsweise den PC kleben zu drfen, muss die Grafik-Hardware Aero voll untersttzen. Dazu bentigt sie ein Interface, das mindestens 2 GByte/s transferiert (also AGP-8X, PCI Express oder einen im Chipsatz integrierten Grafikprozessor). Die erwhnten 64 MByte Grafikspeicher reichen bei Aero nur fr eine Bildschirmauflsung von 1024  768, bis zu 1600  1200 Bildpunkten sind 128 MByte ntig und darber 256 MByte  wobei Aero-taugliche Grafikkarten mit mehreren Ausgngen an jedem Ausgang Aero-tauglich sein mssen, um das Premium- Logo tragen zu drfen. Von den DirectX-9-Funktionen setzt Aero insbesondere Pixel Shader 2.0 voraus. Auch Microsofts strategische Ausrichtung auf HDTV wird in den Logo-Richtlinien deutlicher als es Russel beschreibt: Premium-Logo-Grafiklsungen mssen weitgehende HDTV-Untersttzung mitbringen und die zugehrigen DirectX-Video-Acceleration-Funktionen kennen (DirectX VA 2.0). Besondere Regeln gelten fr x64-Rechner: Whrend die x64-Version von Windows XP zurzeit mangels Treibern und sinnvollen Applikationen ein kmmerliches Schattendasein fristet, will Microsoft die x86-64-Technik mit Vista gehrig anschieben: Fr die x64-Vista-Editionen soll es ein eigenes Logo geben, Microsoft macht Druck auf Hardware-Hersteller, von vornherein auch x64-Treiber zu entwickeln. Viele Fragen dazu klrt eine Vista-Logo-FAQ-Seite. In Bezug auf die Vista-Eignung sind anscheinend die richtigen Treiber wichtiger als ein schneller Hauptprozessor oder ein riesiger Hauptspeicher: Microsoft fhrt mit Vista eine neue Treiber-Architektur ein, die Windows Driver Foundation (WDF). Damit will Microsoft Ziele wie hhere Stabilitt, einfachere Strukturen, bessere Wiederverwendbarkeit von Treiber-Code und mglicherweise auch strengere Kontrolle der Hardware-Schnittstellen erreichen. Vista (und Longhorn Server) unterscheiden zwischen Kernel-Mode Driver Framework (KMDF) und User-Mode Driver Framework (UMDF), fr Grafikkarten gibt es das spezielle Longhorn Device Driver Model (LDDM), die Windows Imaging Architecture (WIA) lst bei Scannern und anderen Bildgebern TWAIN ab. Die wichtigsten PC-Chiphersteller  etwa AMD, ATI, Intel und Nvidia  informieren bereits ber Vista-kompatible Produkte und kommende Treiber. Auch Microsoft gibt Geschftskunden konkretere Tipps zur Hardware-Beschaffung fr Vista. (ciw/c't)");	
		String testTokens="die von DSL- fr";
		
		//Test of Filter
		testFilter.trainFilter(s, "spam");
		testFilter.trainFilter(h, "ham");
		
		//Let's see how much our tokens look like SPAM
		System.out.println("Spam-Value:  "+testFilter.evaluateInput(testTokens, 15));

		//What are the 10 most interesting tokens in the DB
		Iterator test = testFilter.queryDBForInterestingTokens(10);
			while(test.hasNext()){
				TokenContainer temp = (TokenContainer)test.next();
				System.out.println("Token: " + temp.toString() +" with interestingness: "+ temp.getInterestingness());
			}
		
		Iterator test2 = testFilter.queryFilter(testTokens);
			while (test2.hasNext()){
				TokenContainer temp = (TokenContainer)test2.next();
				System.out.println("Details of Token: -=# " + temp.toString() + " #=- are: -->> AppInSpam:"+ temp.getAppearancesInSpam()+ " AppInHam:" + temp.getAppearancesInHam() + " Spammyness:" +temp.getSpammyness());
			}
		
			
	}
		
		catch (SQLException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (ClassNotFoundException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}

	}
}