package filter;

public class TokenContainer implements Comparable{

	private String token;
	private int appearancesInSpam;
	private int appearancesInHam;
	private double spammyness;
	
	//Tuning parameters
	private double maxSpammyness=0.999999;
	private double minSpammyness=0.000001;
	
	
	public TokenContainer(String token, int appearancesInSpam, int appearancesInHam, double spammyness){
		this.token=token;
		this.appearancesInSpam=appearancesInSpam;
		this.appearancesInHam=appearancesInHam;
		
		if(spammyness<minSpammyness)this.spammyness=minSpammyness;
		else if (spammyness>maxSpammyness)this.spammyness=maxSpammyness;
		else this.spammyness=spammyness;
				
	}
	
	private TokenContainer(){}
	
	public String toString(){
		return this.token;
	}
	
	public int getAppearancesInSpam(){
		return this.appearancesInSpam;
	}
	
	public int getAppearancesInHam(){
		return this.appearancesInHam;
	}
	
	public double getSpammyness(){
		return this.spammyness;	
	}
	
	public double getInterestingness(){
		return Math.abs(0.5-spammyness);
	}

	public int compareTo(Object arg0) {
		return (this.spammyness>((TokenContainer)arg0).getInterestingness())?1:0;
	}

	public void setMaxSpammyness(double maxSpammyness){
		this.maxSpammyness=maxSpammyness;
		if (this.spammyness>this.maxSpammyness) this.spammyness=this.maxSpammyness;
	}
	
	public void setMinSpammyness(double minSpammyness){
		this.minSpammyness=minSpammyness;
		if(this.spammyness<this.minSpammyness) this.spammyness=this.minSpammyness;
	}
	
}
