package gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;

import filter.TokenContainer;



public class PopupTokenTable {
	JFrame tokenTableFrame;
	
	private JScrollPane scrollPane;
	private static JTable mT;
	private String[] tableHeader= {"Token","Vorkommen Ham","Vorkommen Spam","Spammyness", "Interestingness"};
	private DefaultTableModel tm;
	private TableSorter tableSorter;
	
	public PopupTokenTable(Vector dataVec) {
		
		tokenTableFrame = new JFrame();
		tokenTableFrame.setTitle("Uebersicht der evaluierten Token");
		tokenTableFrame.addWindowListener(new MyWindowAdapter());
		tokenTableFrame.setLayout(new BorderLayout());
		String[][] tabData = new String[dataVec.size()][5];
		for(int i = 0;i<dataVec.size();i++) {
			TokenContainer tmpContainer = (TokenContainer)dataVec.get(i);
			tabData[i][0] = tmpContainer.toString();
			tabData[i][1] = Double.toString(tmpContainer.getAppearancesInHam());
			tabData[i][2] = Double.toString(tmpContainer.getAppearancesInSpam());
			tabData[i][3] = Double.toString(tmpContainer.getSpammyness());
			tabData[i][4] = Double.toString(tmpContainer.getInterestingness());
		}
		tm = new DefaultTableModel(tabData,tableHeader);
		tableSorter = new TableSorter(tm);
		mT = new JTable(tableSorter);
		tableSorter.setTableHeader(mT.getTableHeader());
		
		//mT = new JTable(tabData,tableHeader);
		mT.setIntercellSpacing(new Dimension(2,6));
		mT.setRowHeight(mT.getRowHeight() + 6);
		mT.setShowVerticalLines(false);
		mT.setBackground(new Color(255,255,255));
		mT.setForeground(Color.black);
		mT.setSelectionBackground(Color.lightGray);
		mT.setSelectionForeground(Color.RED);
		mT.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		DefaultTableCellRenderer ren = new DefaultTableCellRenderer();
		mT.setDefaultRenderer(Object.class, ren);
		
		scrollPane = new JScrollPane(mT);
		tokenTableFrame.add(scrollPane,BorderLayout.CENTER);
		
		tokenTableFrame.setSize(300,300);
		//tokenTableFrame.setVisible(true);
	}
	
	public void showTable() {
		tokenTableFrame.setVisible(true);
	}
}
