package gui;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Properties;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import jcckit.data.DataCurve;
import jcckit.data.DataPlot;
import jcckit.data.DataPoint;
import jcckit.util.ConfigParameters;
import jcckit.util.PropertiesBasedConfigData;
import jcckit.GraphicsPlotCanvas;

public class buildMainPanel {
	private static buildMainPanel instance = null;
	
	private JPanel mainPanel = new JPanel();
	private JButton analyseText = new JButton("Analysiere Text");
	private JButton learnSpam = new JButton("lerne Spam");
	private JButton learnHam = new JButton("lerne Ham");
	private JTextField spamOrHam = new JTextField("  UNKNOWN  ");
	private Font spamOrHamFont = new Font("SansSerif",Font.BOLD,18);
	private JTextArea textArea = new JTextArea(10,60);
	private JScrollPane scrollPane = new JScrollPane(textArea);
	private GridBagLayout gbl = new GridBagLayout();
	private JCheckBox chkAllowPopup = new JCheckBox();
	private JLabel lblAllowPopup = new JLabel("Popup mit bewerteten Token erlauben?");
	private JTextField txtNumberToken = new JTextField("15",4);
	private JLabel lblNumberToken = new JLabel("Anzahl der auszuwertenden Token");

	private DataPlot dataPlot = new DataPlot();
	
	private GraphicsPlotCanvas plotCanvas = createPlotCanvas();
	/**
	 * constuctor is private
	 * Access only through static instance
	 *
	 */
	private buildMainPanel() {
		
	}
	
	public static buildMainPanel getInstance() {
		if(instance == null) {
			instance = new buildMainPanel();
		}
		return instance;
	}
	
	public JPanel getMainPanel() {
		learnSpam.addMouseListener(new MyMouseAdapter());
		learnHam.addMouseListener(new MyMouseAdapter());
		analyseText.addMouseListener(new MyMouseAdapter());
		
		textArea.setLineWrap(true);
		
		spamOrHam.setFont(spamOrHamFont);
		spamOrHam.setForeground(Color.YELLOW);
		spamOrHam.setBackground(Color.GRAY);
		
		mainPanel.setLayout(gbl);
		addComponent(mainPanel, gbl, analyseText, 0,0,2,1,0,0);
		addComponent(mainPanel, gbl, spamOrHam, 2,0,2,2,0,0);
		addComponent(mainPanel, gbl, learnSpam, 0,1,1,1,0,0);
		addComponent(mainPanel, gbl, learnHam, 1,1,1,1,0,0);
		addComponent(mainPanel, gbl, lblNumberToken, 0,2,1,1,0,0);
		addComponent(mainPanel, gbl, txtNumberToken, 1,2,1,1,0,0);
		addComponent(mainPanel, gbl, lblAllowPopup, 2,2,1,1,0,0);
		addComponent(mainPanel, gbl, chkAllowPopup, 3,2,1,1,0,0);
		addComponent(mainPanel, gbl, scrollPane, 0,3,4,1,1.0,1.0);
		
		dataPlot.addElement(new DataCurve(""));
		plotCanvas.connect(dataPlot);
		Canvas c = plotCanvas.getGraphicsCanvas();
		addComponentAWT(mainPanel, gbl, c, 0,4,4,1,1.0,1.0);
		// the chart was not painted without that repaint unter linux
		mainPanel.repaint();
		c.repaint();
		//animate();
		/*new Thread() {
            public void run() {
             animate();
            }
          }.start();
		*/
		
		return mainPanel;
	}
	
	public void txtIsSpam(String str) {
		spamOrHam.setText(str);
		spamOrHam.setForeground(Color.YELLOW);
		spamOrHam.setBackground(Color.RED);
	}
	
	public void txtIsHam(String str) {
		spamOrHam.setText(str);
		spamOrHam.setForeground(Color.YELLOW);
		spamOrHam.setBackground(Color.GREEN);
	}
	
	public String getTextAreaContent() {
		return textArea.getText();
	}
	
	public void setTextAreaContent(String str) {
		textArea.setText(str);
	}
	
	public int getNumberOfEvaluatedTokens() {
		try{
			Integer.parseInt(instance.txtNumberToken.getText());
		}catch(NumberFormatException nfe) {
			instance.textArea.setText("Bitte nur Zahlen eingeben das Feld 'Anzahl der auszuwertenden Token' eingeben!\n\n" + 
					instance.textArea.getText());
		}
		return Integer.parseInt(instance.txtNumberToken.getText());
	}
	
	public boolean getAllowPopup() {
		return instance.chkAllowPopup.isSelected();
	}
	
	public void drawGraph(int[] Spammyness) {
		DataCurve curve = new DataCurve("");
		  for (int i = 0; i < Spammyness.length; i++) {
		    curve.addElement(new DataPoint(i, 0));
		  }
		  dataPlot.replaceElementAt(0, curve);

		  for (int i = 0; i < Spammyness.length; i++) {
		    double x = i;
		    double y = 0;
		    while (y < Spammyness[i]) {
		      try {
		        Thread.sleep(50);
		      } catch (InterruptedException e) {}
		      y = Math.min(Spammyness[i], y + 5);
		      // quick and dirty workaround start
		      if(y<100) {
		    	  	curve.replaceElementAt(i, new DataPoint(x, y));
		      }
		      //quick and dirty workaround end
		    }
		  }
	}
	
	static class MyMouseAdapter extends MouseAdapter {
		public void mousePressed(MouseEvent mevent) {
			JButton hitButton = (JButton)mevent.getSource();
			/* Button 'Clear fields' was hit !*/
			if(hitButton.getText().compareToIgnoreCase("lerne Spam")==0) {
				gui_main.learnTextAsSpam();
			}
			
			if(hitButton.getText().compareToIgnoreCase("lerne Ham")==0) {
				gui_main.learnTextAsHam();
			}
			
			if(hitButton.getText().compareToIgnoreCase("Analysiere Text")==0) {
				/* check if content of txtNumberToken is an integer*/
				
				try{
					Integer.parseInt(instance.txtNumberToken.getText());
					gui_main.analyzeText();
				}catch(NumberFormatException nfe) {
					instance.textArea.setText("Bitte nur Zahlen eingeben das Feld 'Anzahl der auszuwertenden Token' eingeben!\n\n" + 
							instance.textArea.getText());
				}
				
				
			}
		}
	}
	
	private static void addComponent(JPanel cont,
										GridBagLayout gbl,
										JComponent c,
										int x, int y,
										int width, int height,
										double weightx, double weighty) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.insets.bottom=5;
		gbc.insets.top=5;
		gbc.insets.left=5;
		gbc.insets.right=5;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.weightx = weightx;
		gbc.weighty = weighty;
		gbl.setConstraints(c, gbc);
		cont.add(c);
	}
	
	private static void addComponentAWT(JPanel cont,
			GridBagLayout gbl,
			Component c,
			int x, int y,
			int width, int height,
			double weightx, double weighty) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.insets.bottom=5;
		gbc.insets.top=5;
		gbc.insets.left=5;
		gbc.insets.right=5;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.weightx = weightx;
		gbc.weighty = weighty;
		gbl.setConstraints(c, gbc);
		cont.add(c);
}
	
	//test jcckit
	private GraphicsPlotCanvas createPlotCanvas() {
		  Properties props = new Properties();
		  ConfigParameters config = new ConfigParameters(new PropertiesBasedConfigData(props));
		  props.put("plot/legendVisible", "false");
		  props.put("verticalAnchor", "center");
		  props.put("horizontalAnchor", "center");
		  props.put("paper", "-0.1 0 4 1");
		  props.put("plot/coordinateSystem/xAxis/minimum", "-0.5");
		  props.put("plot/coordinateSystem/xAxis/maximum", "9.5");
		  props.put("plot/coordinateSystem/xAxis/axisLength","3.5");
		  
		  props.put("plot/coordinateSystem/xAxis/axisLabel", "Spammyness");
		  props.put("plot/coordinateSystem/xAxis/axisLabelPosition", "0 -0.1");
		  props.put("plot/coordinateSystem/xAxis/ticLabelFormat/className",
		            "jcckit.plot.TicLabelMap");
		  props.put("plot/coordinateSystem/xAxis/ticLabelFormat/map",
		            "0=0-10;1=10-20;2=20-30;3=30-40;4=40-50;5=50-60;6=60-70;7=70-80;8=80-90;9=90-100");
		  props.put("plot/coordinateSystem/yAxis/axisLabel", "# Token");
		  props.put("plot/coordinateSystem/yAxis/axisLength","0.9");
		  props.put("plot/coordinateSystem/yAxis/axisLabelPosition", "-0.15 0");
		  props.put("plot/coordinateSystem/yAxis/maximum", "100");
		  //props.put("plot/coordinateSystem/yAxis/ticLabelFormat", "%d%%");
		  props.put("plot/coordinateSystem/yAxis/ticLabelFormat", "%1f");
		  props.put("plot/curveFactory/definitions", "curve");
		  props.put("plot/curveFactory/curve/withLine", "false");
		  props.put("plot/curveFactory/curve/symbolFactory/className", "jcckit.plot.BarFactory");
		  props.put("plot/curveFactory/curve/symbolFactory/attributes/className",
		            "jcckit.graphic.ShapeAttributes");
		  props.put("plot/curveFactory/curve/symbolFactory/attributes/fillColor", "0xfe8000");
		  props.put("plot/curveFactory/curve/symbolFactory/attributes/lineColor", "0");
		  props.put("plot/curveFactory/curve/symbolFactory/size", "0.15");
		  props.put("plot/initialHintForNextCurve/className", "jcckit.plot.PositionHint");
		  props.put("plot/initialHintForNextCurve/position", "0 0.1");

		  return new GraphicsPlotCanvas(config);
	}	
}
