package gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.util.Vector;


import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;

import filter.TokenContainer;


public class buildTokenTable {
	private static buildTokenTable instance = null;
	
	JPanel tokenPanel;
	JPanel topPanel;
	private JLabel labelTokenToDisplay = new JLabel("Folgende Token sind in der Datenbank enthalten");
	private JScrollPane scrollPane;
	private JTable mT;
	private TableModel tm;
	private TableSorter tableSorter;
	private String[] tableHeader= {"Token","Vorkommen Ham","Vorkommen Spam","Spammyness", "Interestingness"};
	private String[][] initTableData = {{"leer","leer","leer","leer","leer"},{"leer","leer","leer","leer","leer"}};
	
	private buildTokenTable() {
		
	}
	
	public static buildTokenTable getInstance() {
		if(instance == null) {
			instance = new buildTokenTable();
		}
		return instance;
	}
	
	public JPanel getTokenTable() {
		tokenPanel = new JPanel();
		tokenPanel.setLayout(new BorderLayout());
		
		tokenPanel.add(labelTokenToDisplay);
		
		mT = new JTable(initTableData,tableHeader);
		mT.setIntercellSpacing(new Dimension(2,6));
		mT.setRowHeight(mT.getRowHeight() + 6);
		mT.setShowVerticalLines(false);
		mT.setBackground(new Color(255,255,255));
		mT.setForeground(Color.black);
		mT.setSelectionBackground(Color.lightGray);
		mT.setSelectionForeground(Color.RED);
		mT.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		DefaultTableCellRenderer ren = new DefaultTableCellRenderer();
		mT.setDefaultRenderer(Object.class, ren);		
		
		scrollPane = new JScrollPane(mT);
		tokenPanel.add(scrollPane,BorderLayout.CENTER);
		return tokenPanel;
	}

	public void setTokenTable(Vector dataVec) {
		tokenPanel.remove(scrollPane);
		
		tokenPanel.add(labelTokenToDisplay,BorderLayout.NORTH);
		
		String[][] tabData = new String[dataVec.size()][5];
		for(int i = 0;i<dataVec.size();i++) {
			TokenContainer tmpContainer = (TokenContainer)dataVec.get(i);
			tabData[i][0] = tmpContainer.toString();
			tabData[i][1] = Double.toString(tmpContainer.getAppearancesInHam());
			tabData[i][2] = Double.toString(tmpContainer.getAppearancesInSpam());
			tabData[i][3] = Double.toString(tmpContainer.getSpammyness());
			tabData[i][4] = Double.toString(tmpContainer.getInterestingness());
 
		}
		tm = new DefaultTableModel(tabData,tableHeader);
		tableSorter = new TableSorter(tm);
		mT = new JTable(tableSorter);
		tableSorter.setTableHeader(mT.getTableHeader());
		//mT = new JTable(tabData,tableHeader);
		
		mT.setIntercellSpacing(new Dimension(2,6));
		mT.setRowHeight(mT.getRowHeight() + 6);
		mT.setShowVerticalLines(false);
		mT.setBackground(new Color(255,255,255));
		mT.setForeground(Color.black);
		mT.setSelectionBackground(Color.lightGray);
		mT.setSelectionForeground(Color.RED);
		mT.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		DefaultTableCellRenderer ren = new DefaultTableCellRenderer();
		mT.setDefaultRenderer(Object.class, ren);		

		scrollPane = new JScrollPane(mT);
		tokenPanel.add(scrollPane,BorderLayout.CENTER);
	}
}


/*
 * 		//		tableSorter = new TableSorter(initTableData,tableHeader);
		//tm = new DefaultTableModel(initTableData,tableHeader);
		//tableSorter = new TableSorter(tm);
		

		JTable mT = new JTable(initTableData,tableHeader);
		//mT = new JTable(tableSorter);
		//tableSorter.setTableHeader(mT.getTableHeader());

 * 
 * 
 * */
